export declare type AsyncState<R> = {
    loading: boolean;
    error: Error | undefined;
    result: R | undefined;
};
declare type SetLoading<R> = (asyncState: AsyncState<R>) => AsyncState<R>;
declare type SetResult<R> = (result: R, asyncState: AsyncState<R>) => AsyncState<R>;
declare type SetError<R> = (error: Error, asyncState: AsyncState<R>) => AsyncState<R>;
export declare type UseAsyncOptionsNormalized<R> = {
    setLoading: SetLoading<R>;
    setResult: SetResult<R>;
    setError: SetError<R>;
};
export declare type UseAsyncOptions<R> = Partial<UseAsyncOptionsNormalized<R>> | undefined | null;
declare type ArgumentsType<T> = T extends (...args: infer A) => any ? A : never;
export declare type UseAsyncResult<R> = AsyncState<R> & {
    execute: () => void;
};
export declare const useAsync: <R, Fun extends (...args: any[]) => Promise<R>>(asyncFunction: Fun, params: ArgumentsType<Fun>, options?: UseAsyncOptions<R>) => UseAsyncResult<R>;
export {};
